package com.kingfore.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson2.JSONArray;
import com.kingfore.model.CompanyStructure;
import com.kingfore.model.HistoryWarning;
import com.kingfore.utils.CommonUtils;
import com.kingfore.utils.VoiceCallUtils;
import com.mongodb.BasicDBObject;
import com.mongodb.bulk.BulkWriteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.data.mongodb.core.BulkOperations;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.data.mongodb.core.query.Update;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import java.math.BigDecimal;
import java.util.*;

@Service
public class DataServiceImpl {
	private static final Logger logger = LoggerFactory.getLogger(DataServiceImpl.class);
	//对应产品名称：金房报警管理     ProductKey：a1Pgbsas6h8
	@Autowired
	@Qualifier(value = "realDataMongoTemplate")
	private MongoTemplate realDataMongoTemplate;
	
	@Autowired
	@Qualifier(value = "historyDataMongoTemplate")
	private  MongoTemplate historymongoTemplate;
	private static DataServiceImpl dataServiceImpl;
	@PostConstruct  
    public void init() {  
		dataServiceImpl = this;  
		dataServiceImpl.realDataMongoTemplate = this.realDataMongoTemplate; 
		dataServiceImpl.historymongoTemplate = this.historymongoTemplate;
    } 
//	public static void processMessage(Message message) {
//        try {
//			message10102(message);
//		} catch (Exception e) {
//			logger.info("解析失败！！");
//		}
//	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public synchronized static void message10102(Message message) throws Exception {
//		byte[] body = message.getBody(byte[].class);
//		String content = new String(body);
////		String content = "{\"deviceType\":\"CustomCategory\",\"iotId\":\"zV2S2s8CNGGAiUZMotKg000000\",\"requestId\":\"86700\",\"checkFailedData\":{},\"productKey\":\"a1Pgbsas6h8\",\"gmtCreate\":1628066118614,\"deviceName\":\"gcglf1hhrzwrzskzg\",\"items\":{\"alarm\":{\"value\":\"{\\\"name\\\": \\\"yhpdgcwbj\\\", \\\"value\\\": 30.77, \\\"upper\\\": 50.0, \\\"lower\\\": null, \\\"code\\\": 0, \\\"message\\\": \\\"threshold alarm\\\", \\\"desc\\\": \\\"1\\\\u53f7\\\\u914d\\\\u7535\\\\u67dc\\\\u8d85\\\\u6e29\\\\u62a5\\\\u8b66\\\"}\",\"time\":1628066118570}}}";
////		String content="{  \"checkFailedData\": {},  \"deviceName\": \"wrzstest\",  \"deviceType\": \"CustomCategory\",  \"gmtCreate\": 1643333237606,"
////			    + "    \"iotId\": \"kg7jawE8f66z1BqDjZj3000000\",  "
////			    + "    \"items\": { "
////			    + "        \"alarm\": { "
////			    + "            \"time\": 1643333237607, "
////			    + "            \"value\": \"{\\\"name\\\": \\\"gl1gzdm\\\", \\\"value\\\": 3, \\\"code\\\": 5, \\\"message\\\": \\\"event alarm\\\", \\\"desc\\\": \\\"\\\", \\\"time\\\": 1643333237607}\" "
////			    + ""
////			    + "        }"
////			    + "    },"
////			    + "    \"productKey\": \"a1Pgbsas6h8\", "
////			    + "    \"requestId\": \"16477\"    "
////			    + "}";
//		JSONObject json=JSON.parseObject(content);
//
//		String topic = message.getStringProperty("topic");
//		String messageId = message.getStringProperty("messageId");
//		logger.info("收到信息  "+ " topic = " + topic+ "  messageId = " + messageId + "  content = " + content);
//
//		String productKey=json.getString("productKey");
//		String deviceName=json.getString("deviceName");
//		//获取备注
//		String deviceDesc = ALiIotAMQP.QueryDeviceDetail(productKey, deviceName);
//		JSONObject items =json.getJSONObject("items");
//
//		if (items.containsKey("alarm")) {
//			logger.info("报警信息输出内容：   "+content);
//			 //报警开始时间或者结束时间
//			long time = items.getJSONObject("alarm").getLongValue("time");
//        	//报警数据json值
//        	JSONObject jsonObject = JSONObject.parseObject(items.getJSONObject("alarm").getString("value"));
//        	String name = jsonObject.getString("name");
//    		double value = jsonObject.getDoubleValue("value");
//
//    		//查询此条记录
//    		Query query= new Query(new Criteria("_id").is(deviceName+name));
//    		Map map = dataServiceImpl.realDataMongoTemplate.findOne(query, Map.class,"KingFore");
//    		if (map==null){
//    			return;
//    		}
//    		//写入日志信息
////    		WarningLog warningLog = new WarningLog();
////    		warningLog.setCode(jsonObject.getInteger("code"));
////    		warningLog.setRealDataId(deviceName+name);
////    		warningLog.setDeviceName(deviceName);
////    		warningLog.setDeviceDesc(deviceDesc);
////    		warningLog.setValue(value);
////    		warningLog.setAttribute(name);
////    		warningLog.setDateTime(new Date());
////    		warningLog.setProductKey(productKey);
////    		if(map.get("companyStructureId") != null && !"".equals(map.get("companyStructureId"))) {
////    			warningLog.setStructureId((String)map.get("structureId"));
////    		}
////    		if(map.get("companyStructure") != null && !"".equals(map.get("companyStructure"))) {
////    			warningLog.setStructure((String)map.get("companyStructure"));
////    		}
////    		warningLog.setDataName((String)map.get("dataName"));
////
////    		dataServiceImpl.historymongoTemplate.save(warningLog,"KingForeWarningLog");
//    		//报警日志写入结束
//
//
//    		//判断报警历史表是否有该code数据
//    		Query h =Query.query(Criteria.where("dataCode").is(map.get("_id").toString()).and("restoreTime").is(null));
//    		Map his = dataServiceImpl.historymongoTemplate.findOne(h,Map.class, "KingForeHistoryWarning");
//
//    		if(jsonObject.getInteger("code") == 0) {
//    			//报警恢复正常
//    			//修改历史数据库
//    			if(his != null) {
//    				Update update = new Update();
//    				update.set("restoreTime",new Date(time));
//    				dataServiceImpl.historymongoTemplate.updateMulti(h,update,"KingForeHistoryWarning");
//    			}
//    			//修改实时数据库
//    			Update updateRel = new Update();
//    			updateRel.set("deviceDesc", deviceDesc);
//    			updateRel.set("warning", "否");
//    			updateRel.set("warningStartTime", "");
//    			updateRel.set("alarmLevel", "");
//    			dataServiceImpl.realDataMongoTemplate.updateMulti(query, updateRel, "KingFore");
//
//    		}else {
//    			Update update = new Update();
//    			if ("gl1gzdm".equals(name)){
//
//    				update.set("alarmLevel", "高");
//    				switch (jsonObject.getInteger("code")) {
//					case 1:{
//						update.set("warning", "供温超高");
//						break;
//					}
//					case 2:{
//						update.set("warning", "回温超高");
//						break;
//					}
//					case 3:{
//						update.set("warning", "供压超高");
//						break;
//					}
//					case 4:{
//						update.set("warning", "回压超高");
//						break;
//					}
//					case 5:{
//						update.set("warning", "供压过低");
//						break;
//					}
//					case 6:{
//						update.set("warning", "回压过低");
//						break;
//					}
//					case 7:{
//						update.set("warning", "连锁故障");
//						System.err.println("连锁故障不提示！！！！！");
//						return;
//					}
//					case 8:{
//						update.set("warning", "持续下限");
//						break;
//					}
//					case 9:{
//						update.set("warning", "燃烧器故障");
//						break;
//					}
//					case 10:{
//						update.set("warning", "燃气压力异常");
//						break;
//					}
//					case 11:{
//						update.set("warning", "吹扫频率低");
//						break;
//					}
//					case 12:{
//						update.set("warning", "电动阀关闭");
//						break;
//					}
//
//					default:
//						break;
//					}
//
//    			}else{
//	    			//持续报警的时候
//	    			if(jsonObject.getInteger("code") == 1) {
//	    				update.set("warning", "上限");
//	    				update.set("alarmLevel", "中");
//	    				update.set("highLimit", jsonObject.getString("upper"));
//	    			}
//	    			else if(jsonObject.getInteger("code") == 3) {
//	    				update.set("warning", "持续上限");
//	    				update.set("alarmLevel", "高");
//	    				update.set("highLimit", jsonObject.getString("upper"));
//	    			}
//	    			else if(jsonObject.getInteger("code") == 2) {
//	    				update.set("warning", "下限");
//	    				update.set("alarmLevel", "中");
//	    				update.set("lowestLimit", jsonObject.getString("lower"));
//	    			}
//	    			else if(jsonObject.getInteger("code") == 4) {
//	    				update.set("warning", "持续下限");
//	    				update.set("alarmLevel", "低");
//	    				update.set("lowestLimit", jsonObject.getString("lower"));
//	    			}
//	    			else if(jsonObject.getInteger("code") == 5) {
//	    				update.set("warning", "事件报警");
//	    				update.set("alarmLevel", "中");
//	    			}
//	    			else if(jsonObject.getInteger("code") == 6) {
//	    				update.set("warning", "超过最大补水次数");
//	    				update.set("alarmLevel", "中");
//	    				System.err.println("补水不提示！！！！！");
//	    				return;
//	    			}
//	    			else if(jsonObject.getInteger("code") == 7) {
//	    				update.set("warning", "超过最大补水时长");
//	    				update.set("alarmLevel", "中");
//	    				System.err.println("补水不提示！！！！！");
//	    				return;
//	    			} else{
//	    				update.set("warning", "未知报警");
//	    				update.set("alarmLevel", "提醒");
//	    			}
//
//    			}
//    			update.set("deviceDesc", deviceDesc);
//            	update.set("date", new Date());
//            	update.set("warningStartTime", new Date(time));
//            	update.set("value", value);
//            	update.set("dataName", jsonObject.getString("desc"));
//    			//判断此数据点是否已经完成工单，如果完成就把状态标识字段删除
//        		if(map.containsKey("orderState")) {
//        			if((Integer)map.get("orderState") == 1) {
//        				update.unset("orderState");
//        			}
//        		}
//        		//此设备是否存在项目
//            	Query queryStru= new Query(new Criteria("companyStructureId").is(new BasicDBObject("$ne", null)).and("deviceName").is(deviceName));
//            	Map mm = dataServiceImpl.realDataMongoTemplate.findOne(queryStru,Map.class, "KingFore");
//            	CompanyStructure co = JSON.parseObject(JSON.toJSONString(map.get("companyStructure")),CompanyStructure.class);
//            	if(co == null) {
//            		if(mm != null) {
//            			update.set("companyStructureId", mm.get("companyStructureId"));
//                    	update.set("companyStructure", mm.get("companyStructure"));
//            		}
//            	}
//            	dataServiceImpl.realDataMongoTemplate.updateMulti(query,update,"KingFore");
//        		//重新查询去除掉orderState字段的记录
//        		Map delOrder = dataServiceImpl.realDataMongoTemplate.findOne(query, Map.class,"KingFore");
//
//        		//进行拨打电话操作
//        		if(delOrder.get("orderState") == null || "".equals(delOrder.get("orderState"))) {
//        			if(co == null) {
//                		//拨打语音电话
//                		VoiceCallUtils.SingleCallByTts(deviceDesc+"      "+jsonObject.getString("desc")+"     ");
//            		}else {
//            			String structureName = co.getName();
//                		//拨打语音电话
//                		VoiceCallUtils.SingleCallByTts(structureName+"  项目      "+deviceDesc+"      "+jsonObject.getString("desc")+"     ");
//            		}
//        		}
//
//        		if(his == null) {
//        			//没有这条历史记录
//        			HistoryWarning hw = new HistoryWarning();
//        			hw.setAlarmLevel(delOrder.get("alarmLevel").toString());
//        			if(delOrder.get("companyStructureId") != null && !"".equals(delOrder.get("companyStructureId"))) {
//        				hw.setStructureId(delOrder.get("companyStructureId").toString());
//        				hw.setStructureName(co.getName());
//        			}
//    				hw.setDataCode(delOrder.get("_id").toString());
//    				hw.setDataName(delOrder.get("dataName").toString());
//    				hw.setValue(value);
//    				hw.setWarningTime(new Date(time));
//    				hw.setRestoreTime(null);
//    				dataServiceImpl.historymongoTemplate.insert(hw,"KingForeHistoryWarning");
//        		}
//    		}
//
//		}
//		 //不为报警状态同时也不为离线状态进行正常存取数据
//        if (!items.containsKey("alarm") && !items.containsKey("stat")) {
//        	List<Pair<Query, Update>> updateList = new ArrayList<>();
//    		BulkOperations operations=dataServiceImpl.realDataMongoTemplate.bulkOps(BulkOperations.BulkMode.UNORDERED, "KingFore");
//    		JSONObject desc = JSONObject.parseObject(items.getJSONObject("desc").getString("value"));
//        	for(String key:items.keySet()){
//        		if(!"desc".equals(key)) {
//        			double value =  items.getJSONObject(key).getLongValue("value");
//            		long time = items.getJSONObject(key).getLongValue("time");
//            		Query query= new Query(new Criteria("_id").is(deviceName+key));
//            		Update update = new Update();
//            		for (Map.Entry entry : desc.entrySet()) {
//    	    			if(key.equals(entry.getKey())) {
//    	        			update.set("dataName", entry.getValue());
//    		    		}
//    	    		}
//            		update.set("deviceName", deviceName);
//            		update.set("deviceDesc", deviceDesc);
//            		update.set("productKey", productKey);
//            		update.set("date", new Date(time));
//            		update.set("value", value);
//            		update.set("dataCode", deviceName+key);
//            		update.set("attribute", key);
//            		update.set("saveHistory", "是");
//            		update.set("_id", deviceName+key);
//
//            		Pair updatePair =Pair.of(query, update);
//            		updateList.add(updatePair);
//        		}
//    		}
//    		operations.upsert(updateList);
//    		operations.execute();
//
//        }
//	}


	public void  updataRealData(String ip, String port,String topic ,String content,Date date){

		//表名
		String tableNameHis ="KingForeHistoryWarning";
		String tableNameReal ="KingFore";

		//解析topic
		Map<String, Object> topicMap = CommonUtils.expTopic(topic);
		String deviceName = (String) topicMap.get("deviceName");
		String readWrite = (String) topicMap.get("readWrite");
		String dataPointType = (String) topicMap.get("dataPointType");
		String productKey = (String) topicMap.get("productKey");


		//查询实时记录
		Query query = Query.query(Criteria.where("deviceName").is(deviceName));
		List<Map> mapList = dataServiceImpl.realDataMongoTemplate.find(query, Map.class,tableNameReal);
//		if (mapList.isEmpty()){
//			return;
//		}

		//判断数据是否存在
		BulkOperations ops=dataServiceImpl.realDataMongoTemplate.bulkOps(BulkOperations.BulkMode.UNORDERED, tableNameReal);


		Map m = JSON.parseObject(content);
		if(!m.isEmpty()){
			String time =  m.get("flexem_timestamp").toString();
			List<Map> realJson =JSONObject.parseArray(m.get("实际数据").toString(), Map.class);
			List<Map>  warningJson = JSONObject.parseArray(m.get("报警状态").toString(), Map.class);
			List<Map>  warningSetJson = JSONObject.parseArray(m.get("报警设置").toString(), Map.class);
			realJson.addAll(warningSetJson);
			realJson.addAll(warningJson);

			String deviceDesc = (String) m.get("设备名称");



			int updateCount=0;
			int saveCount=0;
			for (Object real : realJson) {
				Map<String,Object> item = (Map) real;
				for (String key : item.keySet()) {
					Map<String, Object> groupOpt = mapList.stream().filter(f -> key.equals(f.get("attribute"))).findAny().orElse(null);
					String value =String.valueOf(item.get(key));
					String id = deviceName + "_" + key.replace("_设定值","_bjsxz");

					if (groupOpt != null) {//有修改
						Update up = new Update();
						//写主题只更新读写状态，读主题更新值
						up.set("value", value);
						up.set("date", date);
						up.set("onLine", "在线");
						Query queryUpdate = Query.query(Criteria.where("deviceName").is(deviceName).and("_id").is(id));
						ops.updateOne(queryUpdate, up);
						updateCount++;
					}else{
						Map<String, Object> realData = new HashMap<>();
						realData.put("_id", id);
						realData.put("dataCode",id);
						realData.put("dataName", key);
						realData.put("value", value);
						realData.put("attribute", key);
						realData.put("date",date);

						realData.put("dataPointType", dataPointType);
						realData.put("productKey", productKey);
						realData.put("deviceName", deviceName);
						realData.put("alarmLevel", "无");
						realData.put("saveHistory", "是");
						realData.put("warning", "否");
						realData.put("onLine", "在线");
						realData.put("custom1", ip);
						realData.put("custom2", port);
						realData.put("custom3", "smart_heating");
						realData.put("deviceDesc", deviceDesc);
						realData.put("topic",topic.replace("up","down"));

						if(key.contains("_报警状态")){
							realData.put("warningStartTime", "");
						}

						if(key.contains("_设定值")){
							realData.put("readWrite", "写");
						}else{
							realData.put("readWrite", "读");
						}
						ops.insert(realData);
						saveCount++;
					}
				}
				//updateCount = setOpt(item, deviceAll, ops, host, port, date, deviceName, dataPointType, updateCount, saveCount);
			}
			//插入或修改

			if (updateCount != 0 || saveCount !=0) {
				BulkWriteResult result = ops.execute();
				logger.info("更新实时记录：" + updateCount);
			}

			//查询报警历史记录
			for(Object warning : warningJson){
				Map<String,Object> item = (Map) warning;
				for (String key : item.keySet()) {
					Map<String, Object> groupOpt = mapList.stream().filter(f -> key.equals(f.get("attribute"))).findAny().orElse(null);
					String value = String.valueOf(item.get(key));
					String id = deviceName + "_" + key;
					if (groupOpt != null) {
						//有修改
						//判断报警历史表是否有该code数据
						Query h =Query.query(Criteria.where("dataCode").is(id).and("restoreTime").is(null));
						Map his = dataServiceImpl.historymongoTemplate.findOne(h,Map.class, tableNameHis);

						Query queryUpdate = Query.query(Criteria.where("deviceName").is(deviceName).and("_id").is(id));

						if(value.equals("0.0") || value.equals("0")) {
							//报警恢复正常
							//修改历史数据库
							if(his != null) {
								Update update = new Update();
								update.set("restoreTime",new Date());
								dataServiceImpl.historymongoTemplate.updateMulti(h,update,tableNameHis);
							}
							//修改实时数据库
							Update updateRel = new Update();
							updateRel.set("deviceDesc", deviceDesc);
							updateRel.set("warning", "否");
							updateRel.set("warningStartTime", "");
							updateRel.set("alarmLevel", "无");
							updateRel.set("value", value);
							updateRel.set("date", date);
							updateRel.set("onLine", "在线");

							dataServiceImpl.realDataMongoTemplate.updateMulti(queryUpdate, updateRel, tableNameReal);

						}else if(value.equals("1.0") || value.equals("1")){
							Update update = new Update();
							update.set("warning", "未知报警");
							update.set("alarmLevel", "提醒");
							update.set("deviceDesc", deviceDesc);
							update.set("date", date);
							update.set("warningStartTime", new Date());
							update.set("value", value);
							update.set("readWrite", "读");
							//判断此数据点是否已经完成工单，如果完成就把状态标识字段删除
							if(groupOpt.containsKey("orderState")) {
								if((Integer)groupOpt.get("orderState") == 1) {
									update.unset("orderState");
								}
							}

							//此设备是否存在项目
							Query queryStru= new Query(new Criteria("companyStructureId").is(new BasicDBObject("$ne", null)).and("deviceName").is(deviceName));
							Map mm = dataServiceImpl.realDataMongoTemplate.findOne(queryStru,Map.class, tableNameReal);
							CompanyStructure co = JSON.parseObject(JSON.toJSONString(groupOpt.get("companyStructure")),CompanyStructure.class);
							if(co == null) {
								if(mm != null) {
									update.set("companyStructureId", mm.get("companyStructureId"));
									update.set("companyStructure", mm.get("companyStructure"));
								}
							}
							dataServiceImpl.realDataMongoTemplate.updateMulti(queryUpdate,update,tableNameReal);
							//重新查询去除掉orderState字段的记录
							Query queryDelOrder =Query.query(Criteria.where("dataCode").is(id));
							Map delOrder = dataServiceImpl.realDataMongoTemplate.findOne(queryDelOrder, Map.class,tableNameReal);

							//进行拨打电话操作
							if(delOrder.get("orderState") == null || "".equals(delOrder.get("orderState"))) {
								if(co == null) {
									//拨打语音电话
									VoiceCallUtils.SingleCallByTts(deviceDesc+"      "+key+"     ");
									logger.info(deviceDesc+"      "+key+"     ");
								}else {
									String structureName = co.getName();
									//拨打语音电话
									VoiceCallUtils.SingleCallByTts(structureName+"  项目      "+deviceDesc+"      "+key+"     ");
									logger.info(structureName+"  项目      "+deviceDesc+"      "+key+"     ");
								}
							}

							if(his == null) {
								//没有这条历史记录
								HistoryWarning hw = new HistoryWarning();
								hw.setAlarmLevel(delOrder.get("alarmLevel").toString());
								if(delOrder.get("companyStructureId") != null && !"".equals(delOrder.get("companyStructureId"))) {
									hw.setStructureId(delOrder.get("companyStructureId").toString());
									hw.setStructureName(co.getName());
								}
								hw.setDataCode(delOrder.get("_id").toString());
								hw.setDataName(delOrder.get("dataName").toString());
								hw.setValue(Double.parseDouble(value));
								hw.setWarningTime(new Date());
								hw.setRestoreTime(null);
								dataServiceImpl.historymongoTemplate.insert(hw,tableNameHis);
							}
						}
					}
				}

			}
		}
		//插入或修改

//		if (updateCount != 0 || saveCount !=0) {
//			BulkWriteResult result = ops.execute();
//			logger.info("更新报警记录：" + updateCount);
//			updateCount= 0;
//			saveCount = 0;
//		}

	}

	public int update(boolean warning,Object obj){
		return 0;
	}

	public int save(boolean warning,Object obj){
		return 0;
	}
}
